#include <attr.bas>
#include "defines.bas"
#include "aticatac_lib.bas"
#include "aticatac_menu.bas"


  ' x and y are character's current position (y=0 is at the top)
  DIM x as UBYTE = 12
  DIM y as UBYTE = 12
  DIM dx as UBYTE
  DIM dy as UBYTE
  DIM nwall, swall, ewall, wwall AS UBYTE ' Character positions of walls of room.  Used to lay out doors etc.
  DIM roomno as UBYTE = 0 ' Current Room Number
  DIM playtype AS UBYTE
  DIM gamefinished AS UBYTE = 0

  WHILE(1=1)

    playtype = MainMenu()
    Initialise()
    DrawScreen()
    MoveTo(y,x)

    WHILE(NOT gamefinished)

      IF (IN($7ffe) BAND 5) = 0 THEN STOP ' BREAK SPACE?
      IF (IN($dffe) BAND 1) = 0 THEN dx = dx + 1  ' P
      IF (IN($dffe) BAND 2) = 0 THEN dx = dx - 1  ' O
      IF (IN($fbfe) BAND 1) = 0 THEN dy = dy - 1  ' Q
      IF (IN($fdfe) BAND 1) = 0 THEN dy = dy + 1  ' A
      IF INKEY$() = "y" THEN gamefinished = 1

      IF dx<>0 OR dy<> 0 THEN
        Move(dy,dx)
        dx = 0
        dy = 0
      END IF
    WEND

    IF(roomno = 0 AND HasACG())
      GameWon()
    END IF

  WEND



  SUB Initialise()
    InitialiseObjects()
    gamefinished = 0
    roomno = 0
    x = 12
    y = 12
  END SUB

  FUNCTION HaveKey(col as UBYTE) AS UBYTE
    col = (col >> 3) BAND 7
    IF(col = 0) RETURN 1  ' No key required!
    IF(col = 2) THEN RETURN GotObject(RED_KEY)
    IF(col = 4) THEN RETURN GotObject(GREEN_KEY)
    IF(col = 5) THEN RETURN GotObject(BLUE_KEY)
    IF(col = 6) THEN RETURN GotObject(YELLOW_KEY)
    RETURN 0
  END FUNCTION

  FUNCTION IsWall(col as UBYTE) AS UBYTE
    IF(col BAND 64) = 0 THEN  ' Non Bright is okay to walk into
      RETURN 0
    ELSE
      RETURN 1
    END IF
  END FUNCTION

  FUNCTION IsDoor(col as UBYTE) AS UBYTE
    IF(col BAND (64+7)) = 3 THEN    ' Door? (Non Bright, Red Ink)
      RETURN 1
    ELSE
      RETURN 0
    END IF
  END FUNCTION

  FUNCTION IsSecretDoor(col as UBYTE) AS UBYTE
    col = col BAND (64+7)
    IF(col = 6 OR col = 5) THEN    ' 6=Bookshelf/Barrel; 5=Clock
      RETURN 1
    ELSE
      RETURN 0
    END IF
  END FUNCTION

  FUNCTION IsTeleport(col as UBYTE) AS UBYTE
    IF(col BAND (64+7)) = 0 THEN    ' Teleport? (Non Bright, Black Ink)
      RETURN 1
    ELSE
      RETURN 0
    END IF
  END FUNCTION

	FUNCTION IsStairs(roomtype AS UBYTE) AS UBYTE
		RETURN (roomtype BAND %1100) = %1000
	END FUNCTION

	FUNCTION IsCavern(roomtype AS UBYTE) AS UBYTE
		RETURN (roomtype BAND %1100) = %0100
	END FUNCTION

  FUNCTION IsWallOrLockedDoor(col as UBYTE) AS UBYTE
    IF (IsWall(col)) THEN RETURN 1
    IF IsDoor(col) AND NOT HaveKey(col) THEN RETURN 1
    RETURN 0
  END FUNCTION


  SUB Teleport(sy as UBYTE, sx AS UBYTE)

    DIM n AS UBYTE
    FOR n = 10 TO 16
      PRINT AT 2+n,3;FLASH 1;BRIGHT 1;INK 6;PAPER 2;" T E L E P O R T I N G ! "
      BEEP .03, 2*n
    NEXT n

		' Get next room number
		roomno = GetNextRoomFromDoorBuffer(sy, sx)
    DrawScreen()

  END SUB

  SUB ChangeRoom(sy as UBYTE, sx AS UBYTE)

		' Which direction did we head off in?
    DIM dir AS UBYTE
    IF(sy = nwall) THEN
      dir = 1
    ELSEIF(sy = swall) THEN
      dir = 2
    ELSEIF(sx = ewall) THEN
      dir = 3
    ELSEIF(sx = wwall) THEN
      dir = 4
    ELSE
      PRINT "Invalid direction: x = ";sx;"; y = ";sy
      STOP
    END IF

		' Get next room number
		roomno = GetNextRoomFromDoorBuffer(sy, sx)
    DrawScreen()

		' Reposition player based on exit position
    IF(dir = 1) THEN
      y = swall - 1
    ELSEIF(dir = 2) THEN
      y = nwall + 1
    ELSEIF(dir = 3) THEN
      x = wwall + 1
    ELSEIF(dir = 4) THEN
      x = ewall - 1
    END IF
    MoveTo(y, x)

  END SUB

  SUB Move(dy as UBYTE, dx AS UBYTE)
    DIM newx AS UBYTE = x + dx
    DIM newy AS UBYTE = y + dy

    ' Check that space isn't occupied...
    DIM col AS UBYTE = attr(newy,newx)
    'PRINT "W?";IsWall(col);"D?";IsDoor(col);"HK?";HaveKey(col);
    IF(NOT IsWallOrLockedDoor(col)) THEN
      IF(IsDoor(col) OR IsSecretDoor(col)) THEN
        ChangeRoom(newy, newx) ' We already know we have the key because it isn't locked!
      ELSEIF(IsTeleport(col)) THEN
        Teleport(newy, newx)
      ELSE
        MoveTo(newy, newx)
      END IF
    ELSEIF(dx <> 0 AND dy <> 0) ' Are we moving diagonally?

      ' Can we consider one direction only?

      ' Check X only direction...
      col = attr(y,newx)
      IF(NOT IsWallOrLockedDoor(col)) THEN
        Move(0, dx)
      ELSE
        ' Check Y only direction...
        col = attr(newy,x)
        IF(NOT IsWallOrLockedDoor(col)) THEN
          Move(dy, 0)
        END IF
      END IF
    END IF
  END SUB


  ' Moves sprite the new position (no checks)
  SUB MoveTo(newy as UBYTE, newx AS UBYTE)
    ASM
    HALT
    END ASM
    PRINT PAPER 8;INK 8;BRIGHT 8;AT y,x;" ";AT newy,newx;"*"
    y = newy
    x = newx
  END SUB


'  FUNCTION DoorKeyColour() AS UBYTE
'    DIM a AS UBYTE = INT(RND()*16)
'    IF(a <> 2 AND a <> 4 AND a <> 6 AND a <> 2) THEN a = 0
'    RETURN a
'  END FUNCTION


  SUB DrawScreen()

    BRIGHT 0:PAPER 0:BORDER 0:INK 7:CLS
		ResetDoorBuffer()

    ' Get address of room information
    MapSetRoom(roomno)

    ' Get Type and Colour
    DIM roomtype AS UBYTE = MapGetRoomType()    'INT(RND()*7)
    DIM roomcolr AS UBYTE = MapGetRoomColour()  'INT(RND()*6)+2  ' RED(2) to WHITE(7)
		'PRINT AT 0,25;"Room "; roomno
		'PRINT AT 1,25;"Type Col"
    'PRINT AT 2,25;roomtype;" ";roomcolr
    PRINT AT 0,25;
    IF(playtype = KNIGHT) THEN PRINT "Knight";
    IF(playtype = WIZARD) THEN PRINT "Wizard";
    IF(playtype = SERF) THEN PRINT "Serf";

    ' Cavern?
    IF(IsCavern(roomtype)) THEN
      roomtype = roomtype - 4
      SetGraphicsBank(1)
    ELSE
      SetGraphicsBank(0)
    END IF

    ' Stairs?
		Dim stairs AS UBYTE = 0
    IF(IsStairs(roomtype)) THEN
      roomtype = roomtype - 8
			stairs = 1
		END IF


    IF(roomtype = 0) THEN     ' Large Square
      nwall = 0: swall = 23: ewall = 23: wwall = 0
    ELSEIF(roomtype = 1) THEN ' Horizontal
      nwall = 8: swall = 23-8: ewall = 23: wwall = 0
    ELSEIF(roomtype = 2) THEN ' Vertical
      nwall = 0: swall = 23: ewall = 23-8: wwall = 8
    ELSEIF(roomtype = 3) THEN ' Octogan
      nwall = 0: swall = 23: ewall = 23: wwall = 0
    ELSE
      PRINT "roomtype ";roomtype;" out of range"
      STOP
    END IF

    ' Draw screen based on the screen type and colour
		DIM n AS UBYTE
    FOR n = wwall TO ewall
      PRINT INK 0;PAPER roomcolr;BRIGHT 1;AT nwall,n;"\B"; AT swall,n;"\B";
    NEXT n
    FOR n = nwall TO swall
      PRINT INK 0;PAPER roomcolr;BRIGHT 1;AT n,ewall;"\A"; AT n,wwall;"\A";
    NEXT n

    IF(roomtype = 3) THEN
      FOR n = 0 TO 3
        PRINT AT n,0;"   ";AT n,21;"   "; AT 23-n,0;"   "; AT 23-n,21;"   "
        PRINT PAPER roomcolr;BRIGHT 1;AT n,3-n;"  ";AT n,19+n;"  ";AT 23-n,3-n;"  ";AT 23-n,19+n;"  "
      NEXT n
    END IF

		IF(stairs = 1) THEN
			DIM l$
			IF(roomtype = 1) THEN	l$ = "\C\C\C\C\C\C\C\C\C\C\C\C\C\C\C\C\C\C\C\C\C\C" ELSE l$ = "\D\D\D\D\D\D"
			FOR n = nwall+1 TO swall-1
				PRINT AT n,wwall+1;PAPER 8;INK 8;l$
			NEXT n
		END IF

    ' Draw the objects in the room
    DrawObjects(roomno)

    ' Add the doors in
    DIM doorcount AS UBYTE = MapGetDoorCount()
		'PRINT AT 0,25;"Doors:";doorcount
    DIM doortype AS UBYTE
    DIM doordir AS UBYTE
		DIM nextroom AS UBYTE

    FOR n = 1 TO doorcount
			MapSetDoorNo(n-1)
			doortype = MapGetDoorType()
			doordir = MapGetDoorDir()
			nextroom = MapGetDoorNextRoom()
			'PRINT AT 1+n,25;doortype;",";doordir;">";nextroom

      IF(doortype < 10) THEN  ' Some kind of door?
        DrawDoor(doortype, doordir, nextroom)
      ELSEIF(doortype = 10) THEN
        DrawTeleport(doordir, nextroom)
      ELSEIF(doortype = 11) THEN
        DrawClock(doordir, nextroom)
      ELSEIF(doortype = 12) THEN
        DrawBookshelf(doordir, nextroom)
      ELSEIF(doortype = 13) THEN
        DrawBarrel(doordir, nextroom)
      ELSEIF(doortype = 14 AND doordir = 0) ' TRAPDOOR_CENTER?
        DrawTeleport(4, nextroom)
      ELSE
        PRINT AT 0,0;"Invalid Door Type ";doortype
        STOP
      END IF

    NEXT n

    IF(roomno = 0 AND HasACG()) THEN BEEP 1,10: gamefinished = 1

  END SUB

  FUNCTION Min(a AS UBYTE, b AS UBYTE) AS UBYTE
    IF(a < b) THEN
      RETURN a
    ELSE
      RETURN b
    END IF
  END FUNCTION

  FUNCTION Max(a AS UBYTE, b AS UBYTE) AS UBYTE
    IF(a > b) THEN
      RETURN a
    ELSE
      RETURN b
    END IF
  END FUNCTION

  SUB DrawTeleport(dir AS UBYTE, nextroom AS UBYTE)
    Dim tx AS UBYTE = 10
    DIM ty AS UBYTE = 10

    IF(dir = 0) THEN      ' North of center
      ty = Max(6,nwall+1)
    ELSEIF(dir = 1) THEN  ' South of center
      ty = Min(15,swall-5)
    ELSEIF(dir = 2) THEN  ' East of center
      tx = Min(15,ewall-5)
    ELSEIF(dir = 3) THEN  ' West of center
      tx = Max(6,wwall+1)
    END IF                ' dir=5 => Center position

    ' Bright 8 stops us overwriting any wall detection; INK 0 indicates a TELEPORT
    PRINT BRIGHT 8;PAPER 3; AT ty,tx;"     "
    PRINT BRIGHT 8;PAPER 3; AT ty+1,tx;" ";PAPER 8; INK 0;"   ";PAPER 3;INK 8;" "
    PRINT BRIGHT 8;PAPER 3; AT ty+2,tx;" ";PAPER 8; INK 0;"   ";PAPER 3;INK 8;" "
    PRINT BRIGHT 8;PAPER 3; AT ty+3,tx;" ";PAPER 8; INK 0;"   ";PAPER 3;INK 8;" "
    PRINT BRIGHT 8;PAPER 3; AT ty+4,tx;"     "
    AddDoorBuffer(ty+1, tx+1, nextroom)
    AddDoorBuffer(ty+1, tx+2, nextroom)
    AddDoorBuffer(ty+1, tx+3, nextroom)
    AddDoorBuffer(ty+2, tx+1, nextroom)
    AddDoorBuffer(ty+2, tx+3, nextroom)
    AddDoorBuffer(ty+3, tx+1, nextroom)
    AddDoorBuffer(ty+3, tx+2, nextroom)
    AddDoorBuffer(ty+3, tx+3, nextroom)

  END SUB

  SUB DrawClock(dir AS UBYTE, nextroom AS UBYTE)
    Dim IsKnight AS UBYTE = 0
    DIM b AS UBYTE = 1
    IF(playtype = KNIGHT) THEN IsKnight = 1 : b = 0

    IF(dir = 0) THEN    ' North
      PRINT BRIGHT b;INK 5;PAPER 0; AT nwall, 7;"CC"
      IF(IsKnight) THEN
        AddDoorBuffer(nwall, 7, nextroom)
        AddDoorBuffer(nwall, 8, nextroom)
			END IF
    ELSEIF(dir = 1) THEN ' South
      PRINT BRIGHT b;INK 5;PAPER 0; AT swall, 7;"CC"
      IF(IsKnight) THEN
        AddDoorBuffer(swall, 7, nextroom)
        AddDoorBuffer(swall, 8, nextroom)
			END IF
    ELSEIF(dir = 2) THEN ' East
      PRINT BRIGHT b;INK 5;PAPER 0; AT 8, ewall;"C"; AT 9, ewall;"C"
      IF(IsKnight) THEN
        AddDoorBuffer(8, ewall, nextroom)
        AddDoorBuffer(9, ewall, nextroom)
			END IF
    ELSEIF(dir = 3) THEN ' West
      PRINT BRIGHT b;INK 5;PAPER 0; AT 8, wwall;"C"; AT 9, wwall;"C"
      IF(IsKnight) THEN
        AddDoorBuffer(8, wwall, nextroom)
        AddDoorBuffer(9, wwall, nextroom)
			END IF
    END IF
  END SUB

  SUB DrawBookshelf(dir AS UBYTE, nextroom AS UBYTE)
    Dim IsWizard AS UBYTE = 0
    DIM b AS UBYTE = 1
    IF(playtype = WIZARD) THEN IsWizard = 1 : b = 0

    IF(dir = 0) THEN    ' North
      PRINT BRIGHT b;INK 6;PAPER 0; AT nwall,9;"BBB"
      IF(IsWizard) THEN
        AddDoorBuffer(nwall, 9, nextroom)
        AddDoorBuffer(nwall, 10, nextroom)
        AddDoorBuffer(nwall, 11, nextroom)
			END IF
    ELSEIF(dir = 1) THEN ' South
      PRINT BRIGHT b;INK 6;PAPER 0; AT swall,9;"BBB"
      IF(IsWizard) THEN
        AddDoorBuffer(swall, 9, nextroom)
        AddDoorBuffer(swall, 10, nextroom)
        AddDoorBuffer(swall, 11, nextroom)
			END IF
    ELSEIF(dir = 2) THEN ' East
      PRINT BRIGHT b;INK 6;PAPER 0; AT 10,ewall;"B"; AT 11,ewall;"B"; AT 12,ewall;"B"
      IF(IsWizard) THEN
        AddDoorBuffer(10, ewall, nextroom)
        AddDoorBuffer(11, ewall, nextroom)
        AddDoorBuffer(12, ewall, nextroom)
			END IF
    ELSEIF(dir = 3) THEN ' West
      PRINT BRIGHT b;INK 6;PAPER 0; AT 10,wwall;"B"; AT 11,wwall;"B"; AT 12,wwall;"B"
      IF(IsWizard) THEN
        AddDoorBuffer(10, wwall, nextroom)
        AddDoorBuffer(11, wwall, nextroom)
        AddDoorBuffer(12, wwall, nextroom)
			END IF
    END IF
  END SUB

  SUB DrawBarrel(dir AS UBYTE, nextroom AS UBYTE)
    Dim IsSerf AS UBYTE = 0
    DIM b AS UBYTE = 1
    IF(playtype = SERF) THEN IsSerf = 1 : b = 0

    IF(dir = 0) THEN    ' North
      PRINT BRIGHT b;INK 6;PAPER 0; AT nwall,10;"OOO"
      IF(IsSerf) THEN
        AddDoorBuffer(nwall, 10, nextroom)
        AddDoorBuffer(nwall, 11, nextroom)
        AddDoorBuffer(nwall, 12, nextroom)
			END IF
    ELSEIF(dir = 1) THEN ' South
      PRINT BRIGHT b;INK 6;PAPER 0; AT swall,10;"OOO"
      IF(IsSerf) THEN
        AddDoorBuffer(swall, 10, nextroom)
        AddDoorBuffer(swall, 11, nextroom)
        AddDoorBuffer(swall, 12, nextroom)
			END IF
    ELSEIF(dir = 2) THEN ' East
      PRINT BRIGHT b;INK 6;PAPER 0; AT 10, ewall;"O"; AT 11, ewall;"O"; AT 12, ewall;"O"
      IF(IsSerf) THEN
        AddDoorBuffer(10, ewall, nextroom)
        AddDoorBuffer(11, ewall, nextroom)
        AddDoorBuffer(12, ewall, nextroom)
			END IF
    ELSEIF(dir = 3) THEN ' West
      PRINT BRIGHT b;INK 6;PAPER 0; AT 10, wwall;"O"; AT 11, wwall;"O"; AT 12, wwall;"O"
      IF(IsSerf) THEN
        AddDoorBuffer(10, wwall, nextroom)
        AddDoorBuffer(11, wwall, nextroom)
        AddDoorBuffer(12, wwall, nextroom)
			END IF
    END IF
  END SUB

  SUB DrawDoor(type AS UBYTE, dir AS UBYTE, nextroom AS UBYTE)
    ' Normal or Alternative Layout?
    IF(type BAND 1) THEN
			dir = dir + 4  ' 0..7
		END IF
    type = type / 2                     ' 0=Door; 1=Red; 2=Blue; 3=Green; 4=Yellow
    DIM col AS UBYTE
    IF(type = 0) THEN
      col = 0
    ELSEIF(type = 1) THEN
      col = 2   ' Red
    ELSEIF(type = 2) THEN
      col = 5   ' Cyan (Blue Key)
    ELSEIF(type = 3) THEN
      col = 4   ' Green
    ELSE
      col = 6   ' Yellow
    END IF

    IF(dir = 0) THEN    ' North Door
      PRINT INK 3;PAPER col; AT nwall, 10;"\:'\''\''\':"
			AddDoorBuffer(nwall, 10, nextroom)
			AddDoorBuffer(nwall, 11, nextroom)
			AddDoorBuffer(nwall, 12, nextroom)
			AddDoorBuffer(nwall, 13, nextroom)
    ELSEIF(dir = 1) THEN ' South Door
      PRINT INK 3;PAPER col; AT swall, 10;"\:.\..\..\.:"
			AddDoorBuffer(swall, 10, nextroom)
			AddDoorBuffer(swall, 11, nextroom)
			AddDoorBuffer(swall, 12, nextroom)
			AddDoorBuffer(swall, 13, nextroom)
    ELSEIF(dir = 2) THEN ' East Door
      PRINT INK 3;PAPER col; AT 10,ewall;"\':"; AT 11,ewall;"\ :"; AT 12,ewall;"\ :"; AT 13,ewall;"\.:";
			AddDoorBuffer(10, ewall, nextroom)
			AddDoorBuffer(11, ewall, nextroom)
			AddDoorBuffer(12, ewall, nextroom)
			AddDoorBuffer(13, ewall, nextroom)
    ELSEIF(dir = 3) THEN ' West Door
      PRINT INK 3;PAPER col; AT 10,wwall;"\:'"; AT 11,wwall;"\: "; AT 12,wwall;"\: "; AT 13,wwall;"\:.";
			AddDoorBuffer(10, wwall, nextroom)
			AddDoorBuffer(11, wwall, nextroom)
			AddDoorBuffer(12, wwall, nextroom)
			AddDoorBuffer(13, wwall, nextroom)
    ELSEIF(dir = 4) THEN ' North West
      PRINT INK 3;PAPER col; AT nwall, 10-3;"\:'\''\''\':"
			AddDoorBuffer(nwall, 10-3, nextroom)
			AddDoorBuffer(nwall, 11-3, nextroom)
			AddDoorBuffer(nwall, 12-3, nextroom)
			AddDoorBuffer(nwall, 13-3, nextroom)
    ELSEIF(dir = 5) THEN ' South East
      PRINT INK 3;PAPER col; AT nwall, 10+3;"\:'\''\''\':"
			AddDoorBuffer(nwall, 10+3, nextroom)
			AddDoorBuffer(nwall, 11+3, nextroom)
			AddDoorBuffer(nwall, 12+3, nextroom)
			AddDoorBuffer(nwall, 13+3, nextroom)
    ELSEIF(dir = 6) THEN ' South East
      PRINT INK 3;PAPER col; AT swall, 10+3;"\:.\..\..\.:"
			AddDoorBuffer(swall, 10+3, nextroom)
			AddDoorBuffer(swall, 11+3, nextroom)
			AddDoorBuffer(swall, 12+3, nextroom)
			AddDoorBuffer(swall, 13+3, nextroom)
    ELSEIF(dir = 7) THEN ' South West
      PRINT INK 3;PAPER col; AT swall, 10-3;"\:.\..\..\.:"
			AddDoorBuffer(swall, 10-3, nextroom)
			AddDoorBuffer(swall, 11-3, nextroom)
			AddDoorBuffer(swall, 12-3, nextroom)
			AddDoorBuffer(swall, 13-3, nextroom)
    ELSE
      PRINT AT 0,0;"Invalid dir ";dir
      STOP
    END IF

  END SUB



  SUB SetGraphicsBank (bank AS UBYTE)
    IF bank=0 THEN
      POKE UINTEGER 23675, @roomgraphicsbank
    ELSE
      POKE UINTEGER 23675, @caverngraphicsbank
    END IF
  END SUB

caverngraphicsbank:
  ASM
  DEFB $C7, $8F, $8F, $C7, $E3, $F1, $F1, $E3 ; A - |
  DEFB 255,240,240,240,15,15,15,255 ; B - -
  END ASM

roomgraphicsbank:
  ASM
  DEFB 0,0,0,0,0,0,0,0 ; A - |
  DEFB 0,0,0,0,0,0,0,0 ; B - -
  DEFB 0,0,16,32,126,32,16,0 ; C - Stairs Up West
  DEFB 0,16,16,16,64+16+4,56,16,0 ; D - Stiars Up South
  END ASM

#include "aticatac_map.bas"







